diff -Naur -X diff_ignore rsync-3.0.6_base/flist.c rsync/flist.c
--- rsync-3.0.6_base/flist.c	2019-01-14 13:23:05.000000000 -0500
+++ rsync/flist.c	2019-01-14 17:30:20.000000000 -0500
@@ -25,6 +25,13 @@
 #include "rounding.h"
 #include "io.h"
 
+// For statfs():
+//#include <sys/param.h>
+//#include <sys/mount.h>
+
+// For _PATH_RSRCFORKSPEC
+#include <sys/paths.h>
+
 extern int verbose;
 extern int am_root;
 extern int am_server;
@@ -48,6 +55,10 @@
 extern int preserve_gid;
 extern int preserve_acls;
 extern int preserve_xattrs;
+extern int preserve_hfs_compression;
+extern int fs_supports_native_xattrs;
+extern uid_t dest_file_owner;
+extern time_t max_age;
 extern int preserve_links;
 extern int preserve_hard_links;
 extern int preserve_devices;
@@ -74,6 +85,9 @@
 extern int unsort_ndx;
 extern struct stats stats;
 extern char *filesfrom_host;
+extern int detect_case_conflicts;
+extern int sparse_files;
+extern const char *srcRoot;
 
 extern char curr_dir[MAXPATHLEN];
 
@@ -131,6 +145,24 @@
 static void flist_sort_and_clean(struct file_list *flist, int strip_root);
 static void output_flist(struct file_list *flist);
 
+// BOMBICH
+struct timeval last_update;
+static unsigned long msdiff(struct timeval *t1, struct timeval *t2)
+{
+	return (t2->tv_sec - t1->tv_sec) * 1000L
+		+ (t2->tv_usec - t1->tv_usec) / 1000;
+}
+
+int knownSIPProtectedDirectory(char *fname)
+{
+	int knownSIPRestrictedDirectory = strstr(fname, "/private/var/folders") != NULL ||
+	strstr(fname, "/private/var/db/ConfigurationProfiles") != NULL ||
+	strstr(fname, "Library/VoiceTrigger/SAT") != NULL ||
+	strstr(fname, "com.apple.mail/Data/DataVaults") != NULL;
+
+	return knownSIPRestrictedDirectory;
+}
+
 void init_flist(void)
 {
 	if (verbose > 4) {
@@ -144,7 +176,7 @@
 
 static int show_filelist_p(void)
 {
-	return verbose && xfer_dirs && !am_server && !inc_recurse;
+	return verbose > 1 && xfer_dirs && !am_server && !inc_recurse;
 }
 
 static void start_filelist_progress(char *kind)
@@ -162,18 +194,40 @@
 
 static void maybe_emit_filelist_progress(int count)
 {
+// BOMBICH
+#ifdef PARSEABLE_OUTPUT
+	struct timeval now;
+	gettimeofday(&now, NULL);
+	unsigned long time_diff = msdiff(&last_update, &now);
+
+
+//	if (!inc_recurse && xfer_dirs && !am_server && !am_generator && (count % 100) == 0 && count > 0)
+	// Update every half second (max). We also want to update on the very first file in case
+	// the first item is a huge file and we're caculating a checksum
+	if (!inc_recurse && xfer_dirs && !am_server && !am_generator && (count == 0 || time_diff > 500)) {
+		last_update = now;
+		rprintf(FINFO, "S;;;BFL;;;NOF;;;%d\n", count);
+	}
+#else
 	if (do_progress && show_filelist_p() && (count % 100) == 0)
 		emit_filelist_progress(count);
+#endif
 }
 
 static void finish_filelist_progress(const struct file_list *flist)
 {
+// BOMBICH
+#ifdef PARSEABLE_OUTPUT
+	if (!inc_recurse)
+		rprintf(FINFO, "S;;;FTC;;;NOF;;;%d;;;BT;;;%.3f;;;TS;;;%s\n", flist->used, (double)stats.flist_buildtime/1000, human_num(stats.total_size));
+#else
 	if (do_progress) {
 		/* This overwrites the progress line */
 		rprintf(FINFO, "%d file%sto consider\n",
 			flist->used, flist->used == 1 ? " " : "s ");
 	} else
 		rprintf(FINFO, "done\n");
+#endif
 }
 
 void show_flist_stats(void)
@@ -379,7 +433,7 @@
 	if (!change_dir(dir, CD_NORMAL)) {
 	  chdir_error:
 		io_error |= IOERR_GENERAL;
-		rsyserr(FERROR_XFER, errno, "change_dir %s failed", full_fname(dir));
+		rsyserr(FERROR_XFER, errno, "change_pathname: change_dir %s failed", full_fname(dir));
 		if (dir != orig_dir)
 			change_dir(orig_dir, CD_NORMAL);
 		pathname = NULL;
@@ -408,7 +462,7 @@
 	static uint32 rdev_major;
 	static uid_t uid;
 	static gid_t gid;
-	static const char *user_name, *group_name;
+	static const char *user_name=NULL, *group_name=NULL;
 	static char lastname[MAXPATHLEN];
 	int first_hlink_ndx = -1;
 	int l1, l2;
@@ -436,6 +490,8 @@
 			xflags |= XMIT_SAME_FLAGS;
 		else
 			fileflags = F_FFLAGS(file);
+	} else {
+		fileflags = 0;
 	}
 #endif
 
@@ -556,19 +612,41 @@
 
 	if (first_hlink_ndx >= 0) {
 		write_varint(f, first_hlink_ndx);
+		// BOMBICH
+		stats.hard_links_not_copied++;
+		// make_file() adds every hard link's size to total_size,
+		// so decrement the unsent files here
+		stats.total_size -= F_LENGTH(file);
+		if (verbose > 1)
+			fprintf(stderr, "DEBUG: [%s] SENDFE: stats.total_size |%s|-%lu|%lld|\n", who_am_i(), full_fname(fname), (unsigned long)F_LENGTH(file), stats.total_size);
 		if (first_hlink_ndx >= first_ndx)
-			goto the_end;
+ 			goto the_end;
 	}
 
 	write_varlong30(f, F_LENGTH(file), 3);
 	if (!(xflags & XMIT_SAME_TIME)) {
-		if (protocol_version >= 30)
+		if (protocol_version >= 30) {
 			write_varlong(f, modtime, 4);
-		else
+#if SIZEOF_TIME_T < SIZEOF_INT64
+			if ((int64)(time_t)modtime != modtime) {
+				rprintf(FERROR_XFER,
+				    "Modification time value truncated on sender: \"%s\".\n",
+				    lastname);
+			}
+#endif
+		} else
 			write_int(f, modtime);
 	}
-	if (crtimes_ndx && !(xflags & XMIT_CRTIME_EQ_MTIME))
+	if (crtimes_ndx && !(xflags & XMIT_CRTIME_EQ_MTIME)) {
 		write_varlong(f, crtime, 4);
+#if SIZEOF_TIME_T < SIZEOF_INT64
+		if ((int64)(time_t)crtime != crtime) {
+			rprintf(FERROR_XFER,
+				"Create time value truncated on sender: \"%s\".\n",
+				lastname);
+		}
+#endif
+	}
 	if (!(xflags & XMIT_SAME_MODE))
 		write_int(f, to_wire_mode(mode));
 #ifdef SUPPORT_FILEFLAGS
@@ -581,7 +659,7 @@
 		else {
 			write_varint(f, uid);
 			if (xflags & XMIT_USER_NAME_FOLLOWS) {
-				int len = strlen(user_name);
+                int len = user_name ? strlen(user_name) : 0;
 				write_byte(f, len);
 				write_buf(f, user_name, len);
 			}
@@ -593,7 +671,7 @@
 		else {
 			write_varint(f, gid);
 			if (xflags & XMIT_GROUP_NAME_FOLLOWS) {
-				int len = strlen(group_name);
+                int len = group_name ? strlen(group_name) : 0;
 				write_byte(f, len);
 				write_buf(f, group_name, len);
 			}
@@ -652,8 +730,19 @@
   the_end:
 	strlcpy(lastname, fname, MAXPATHLEN);
 
-	if (S_ISREG(mode) || S_ISLNK(mode))
-		stats.total_size += F_LENGTH(file);
+	// BOMBICH
+	// Maintain stats on the sender side
+	if (S_ISDIR(mode))
+		stats.num_dirs++;
+	else if (S_ISREG(mode))
+		stats.num_reg_files++;
+	else if (S_ISLNK(mode))
+		stats.num_symlinks++;
+	else if (IS_DEVICE(mode))
+		stats.num_devices++;
+	else if (IS_SPECIAL(mode))
+		stats.num_special++;
+
 }
 
 static struct file_struct *recv_file_entry(struct file_list *flist,
@@ -776,6 +865,10 @@
 				linkname_len = strlen(F_SYMLINK(first)) + 1;
 			else
 				linkname_len = 0;
+			if (preserve_fileflags)
+				fileflags = F_FFLAGS(first);
+			else
+				fileflags = 0;
 			goto create_object;
 		}
 	}
@@ -788,8 +881,8 @@
 #if SIZEOF_TIME_T < SIZEOF_INT64
 			if (!am_generator && (int64)(time_t)modtime != modtime) {
 				rprintf(FERROR_XFER,
-				    "Time value of %s truncated on receiver.\n",
-				    lastname);
+				    "Modification time value truncated on receiver: %s.\n",
+				    full_fname(lastname));
 			}
 #endif
 		} else
@@ -801,8 +894,8 @@
 #if SIZEOF_TIME_T < SIZEOF_INT64
 			if (!am_generator && (int64)(time_t)crtime != crtime) {
 				rprintf(FERROR_XFER,
-				    "Create time value of %s truncated on receiver.\n",
-				    lastname);
+				    "Create time value truncated on receiver: %s.\n",
+				    full_fname(lastname));
 			}
 #endif
 		} else
@@ -816,6 +909,8 @@
 #ifdef SUPPORT_FILEFLAGS
 	if (preserve_fileflags && !(xflags & XMIT_SAME_FLAGS))
 		fileflags = (uint32)read_int(f);
+	else if (!preserve_fileflags)
+		fileflags = 0;
 #endif
 
 	if (preserve_uid && !(xflags & XMIT_SAME_UID)) {
@@ -961,6 +1056,8 @@
 #ifdef SUPPORT_FILEFLAGS
 	if (preserve_fileflags)
 		F_FFLAGS(file) = fileflags;
+	else
+		F_FFLAGS(file) = 0;
 #endif
 	if (preserve_uid)
 		F_OWNER(file) = uid;
@@ -1109,12 +1206,22 @@
 #endif
 #ifdef SUPPORT_XATTRS
 	if (preserve_xattrs)
-		receive_xattr(file, f );
+		receive_xattr(file, f);
 #endif
 
-	if (S_ISREG(mode) || S_ISLNK(mode))
+	if (S_ISREG(mode))
 		stats.total_size += file_length;
 
+	if (am_generator) {
+		// Maintain stats on the receiver side. This is for the benefit of the 
+		// generator -- the receive generator prints out non-transfer related
+		// progress info several times a second. Having the number of reg_files
+		// is helpful for progess indication
+		// BOMBICH
+		if (S_ISDIR(mode))
+			stats.num_dirs++;
+	}
+	
 	return file;
 }
 
@@ -1131,7 +1238,7 @@
 struct file_struct *make_file(const char *fname, struct file_list *flist,
 			      STRUCT_STAT *stp, int flags, int filter_level)
 {
-	static char *lastdir;
+	static char *lastdir = NULL;
 	static int lastdir_len = -1;
 	struct file_struct *file;
 	char thisname[MAXPATHLEN];
@@ -1148,6 +1255,7 @@
 		rprintf(FERROR_XFER, "skipping overly long name: %s\n", fname);
 		return NULL;
 	}
+	
 	clean_fname(thisname, 0);
 	if (sanitize_paths)
 		sanitize_path(thisname, thisname, "", 0, SP_DEFAULT);
@@ -1181,6 +1289,7 @@
 					full_fname(thisname));
 			} else
 #endif
+
 			{
 				enum logcode c = am_daemon && protocol_version < 28
 					       ? FERROR : FWARNING;
@@ -1189,9 +1298,14 @@
 					full_fname(thisname));
 			}
 		} else {
-			io_error |= IOERR_GENERAL;
-			rsyserr(FERROR_XFER, save_errno, "readlink_stat(%s) failed",
-				full_fname(thisname));
+			int knownSIPRestrictedDirectory = knownSIPProtectedDirectory(full_fname(thisname));
+			if (save_errno == EPERM && knownSIPRestrictedDirectory) {
+				fprintf(stderr, "DEBUG: [%s] SIP prevented access to %s\n", who_am_i(), full_fname(thisname));
+			} else {
+				io_error |= IOERR_GENERAL;
+				rsyserr(FERROR_XFER, save_errno, "[%s] make_file: readlink_stat(%s) failed",
+						who_am_i(), full_fname(thisname));
+			}
 		}
 		return NULL;
 	}
@@ -1237,6 +1351,52 @@
 				return NULL;
 	}
 
+	if (!S_ISDIR(st.st_mode) && max_age > 0 && cmp_time(max_age, st.st_mtime) > 0) {
+		rprintf(FERROR, "DEBUG: %s is over max-age\n", full_fname(thisname));
+		return NULL;
+	}
+
+
+#ifdef SUPPORT_HFS_COMPRESSION
+	// There are two ways to do this math. We can either take the uncompressed file size here and add that to total_size, then do the same in sender:send_file_entry. That gives us a value similar to what the Finder offers on a per-folder basis for folders containing lots of compressed files. That value is higher overall than the actual space consumed, though, so we can get total values > source disk usage, which could be confusing.
+	// The second option is to discard the size here and instead add the size of the decmpfs-related xattrs to total_size. Those values are more realistic, but unfortunately we don't know the size of those xattrs without reading them, and we don't want to read them if we're not actually copying them.
+	// With exclusions, the discrepancy between source size and source disk usage is likely to go unnoticied, so I'm choosing the Finder math method.
+	
+	// Sparse files make this yet more complicated... If this file appears to be a sparse file, we'll include its physical size in total_size rather than its logical size
+	off_t physicalSize, logicalSize, reportedFileSize = st.st_size;
+	
+	if (sparse_files) {
+		physicalSize = 512 * st.st_blocks;
+		logicalSize = st.st_size;
+		if ((logicalSize - physicalSize) > st.st_blksize)
+			reportedFileSize = physicalSize;
+		}
+
+	
+	// To use the non-Finder math method: Move this block of code below the next to discard the uncompressed file size and use only the xattr sizes instead
+	if (S_ISREG(st.st_mode)) {
+		stats.total_size += reportedFileSize;
+		if (verbose > 1)
+			fprintf(stderr, "DEBUG: [%s] MKFILE: stats.total_size |%s|+%llu|%lld|\n", who_am_i(), full_fname(thisname), reportedFileSize, stats.total_size);
+		if (reportedFileSize > stats.largest_file)
+			stats.largest_file = reportedFileSize;
+	}
+	
+	if (st.st_flags & UF_COMPRESSED) {
+		if (verbose > 1)
+			fprintf(stderr, "make_file(%s): Handling compressed file: %s\n", who_am_i(), thisname);
+		if (preserve_hfs_compression > 0) {
+			st.st_size = 0;
+		} else {
+			// If the sender's filesystem supports compression, then we'll be able to send the decompressed data fork
+			// and the decmpfs xattr will be hidden (not sent). As such, we need to strip the compression flag.
+			if (verbose > 1)
+				fprintf(stderr, "make_file(%s): Stripping UF_COMPRESSED from st.st_flags for %s\n", who_am_i(), thisname);
+			st.st_flags &= ~UF_COMPRESSED;
+		}
+	}
+#endif
+
   skip_filters:
 
 	/* Only divert a directory in the main transfer. */
@@ -1287,6 +1447,11 @@
 		extra_len += EXTRA_LEN;
 #endif
 
+	// BOMBICH
+	// Prime the output if we're calculating checksums
+	if (always_checksum && st.st_size > 10000000 && am_sender && S_ISREG(st.st_mode) && inc_recurse)
+		rprintf(FINFO, "S;;;CP;;;CF;;;%s\n", thisname);
+
 	if (always_checksum && am_sender && S_ISREG(st.st_mode)) {
 		file_checksum(thisname, tmp_sum, st.st_size);
 		if (sender_keeps_checksum)
@@ -1349,7 +1514,12 @@
 		F_FFLAGS(file) = st.st_flags;
 #endif
 	if (uid_ndx) /* Check uid_ndx instead of preserve_uid for del support */
+	{
+		if (dest_file_owner != 0)
+			F_OWNER(file) = dest_file_owner;
+		else
 		F_OWNER(file) = st.st_uid;
+	}
 	if (gid_ndx) /* Check gid_ndx instead of preserve_gid for del support */
 		F_GROUP(file) = st.st_gid;
 	if (crtimes_ndx)
@@ -1399,6 +1569,19 @@
 	if (!file)
 		return NULL;
 
+//	rprintf(FINFO, "make_file (%s): %s\n", who_am_i());
+//	// BOMBICH
+//	if (S_ISDIR(file->mode))
+//		stats.num_dirs++;
+//	else if (S_ISREG(file->mode))
+//		stats.num_reg_files++;
+//	else if (S_ISLNK(file->mode))
+//		stats.num_symlinks++;
+//	else if (IS_DEVICE(file->mode))
+//		stats.num_devices++;
+//	else if (IS_SPECIAL(file->mode))
+//		stats.num_special++;
+//
 	if (chmod_modes && !S_ISLNK(file->mode))
 		file->mode = tweak_mode(file->mode, chmod_modes);
 
@@ -1420,7 +1603,7 @@
 			symlink_name = F_SYMLINK(file);
 			symlink_len = strlen(symlink_name);
 			if (symlink_len == 0) {
-				io_error |= IOERR_GENERAL;
+				//io_error |= IOERR_GENERAL; // BOMBICH: I don't want an invalid symlink to prevent deletions from occurring
 				f_name(file, fbuf);
 				rprintf(FERROR_XFER,
 				    "skipping symlink with 0-length value: %s\n",
@@ -1494,10 +1677,33 @@
 #ifdef SUPPORT_XATTRS
 		if (preserve_xattrs) {
 			sx.st.st_mode = file->mode;
+			if (verbose > 1 && preserve_fileflags)
+				fprintf(stderr, "Setting sx.st.st_flags to %d\n", F_FFLAGS(file));
+			if (preserve_fileflags)
+				sx.st.st_flags = F_FFLAGS(file);
 			sx.xattr = NULL;
+			
+			if (one_file_system && (file->flags & FLAG_MOUNT_DIR)) {
+				fprintf(stderr, "DEBUG: [%s] Skipping xattrs on %s because it lies across device boundaries\n", who_am_i(), full_fname(fname));
+				sx.xattr = new(item_list);
+				sx.xattr->items = NULL;
+				sx.xattr->count = 0;
+				sx.xattr->malloced = 0;
+			} else
+			
 			if (get_xattr(fname, &sx) < 0) {
-				io_error |= IOERR_GENERAL;
-				return NULL;
+				// Don't bail on an entire directory for xattr problems!
+				if (S_ISDIR(file->mode)) {
+					sx.xattr = new(item_list);
+					sx.xattr->items = NULL;
+					sx.xattr->count = 0;
+					sx.xattr->malloced = 0;
+					rprintf(FERROR, "DEBUG: send_file_name: get_xattr() failed for directory: %s. Proceeding anyway...\n",
+						full_fname(fbuf));
+				} else {
+					io_error |= IOERR_GENERAL;
+					return NULL;
+				}
 			}
 		}
 #endif
@@ -1510,6 +1716,8 @@
 
 #ifdef SUPPORT_ACLS
 		if (preserve_acls && !S_ISLNK(file->mode)) {
+//			fprintf(stderr, "DEBUG: send_f_name: Calling send_acl() for %s\n", f_name(file, NULL));
+//			send_acl(fbuf, &sx, f);
 			send_acl(&sx, f);
 			free_acl(&sx);
 		}
@@ -1517,6 +1725,8 @@
 #ifdef SUPPORT_XATTRS
 		if (preserve_xattrs) {
 			F_XATTR(file) = send_xattr(&sx, f);
+			if (verbose)
+				fprintf(stderr, "DEBUG: send_f_name: f: %#x, ndx: %d |%s\n", F_FFLAGS(file), F_XATTR(file), f_name(file, NULL));
 			free_xattr(&sx);
 		}
 #endif
@@ -1672,11 +1882,12 @@
 			is_dir ? "directory" : "file", full_fname(fname));
 	} else {
 		io_error |= IOERR_GENERAL;
-		rsyserr(FERROR_XFER, errno, "link_stat %s failed",
-			full_fname(fname));
+		rsyserr(FERROR_XFER, errno, "[%s]link_stat: %s failed",
+			who_am_i(), full_fname(fname));
 	}
 }
 
+
 /* This function is normally called by the sender, but the receiving side also
  * calls it from get_dirlist() with f set to -1 so that we just construct the
  * file list in memory without sending it over the wire.  Also, get_dirlist()
@@ -1692,6 +1903,7 @@
 	int divert_dirs = (flags & FLAG_DIVERT_DIRS) != 0;
 	int start = flist->used;
 	int filter_level = f == -2 ? SERVER_FILTERS : ALL_FILTERS;
+	int saved_filter_level = filter_level;
 
 	assert(flist != NULL);
 
@@ -1701,29 +1913,103 @@
 				interpret_stat_error(fbuf, True);
 			return;
 		}
-		io_error |= IOERR_GENERAL;
-		rsyserr(FERROR_XFER, errno, "opendir %s failed", full_fname(fbuf));
+		int knownSIPRestrictedDirectory = knownSIPProtectedDirectory(full_fname(fbuf));
+		if (errno == EPERM && knownSIPRestrictedDirectory) {
+			fprintf(stderr, "DEBUG: [%s] SIP prevented access to %s\n", who_am_i(), full_fname(fbuf));
+		} else {
+			if (strstr(full_fname(fbuf), "com.apple.TCC") == NULL) // Don't suspend deletions if this is the only item we can't copy
+				io_error |= IOERR_GENERAL;
+			rsyserr(FERROR_XFER, errno, "[%s]send_directory: opendir %s failed", who_am_i(), full_fname(fbuf));
+		}
 		return;
 	}
 
 	p = fbuf + len;
-	if (len != 1 || *fbuf != '/')
+	if (len == 1 && *fbuf == '/')
+		remainder = MAXPATHLEN - 1;
+	else if (len < MAXPATHLEN-1) {
 		*p++ = '/';
-	*p = '\0';
-	remainder = MAXPATHLEN - (p - fbuf);
+		*p = '\0';
+		remainder = MAXPATHLEN - (len + 1);
+	} else
+		remainder = 0;
 
 	for (errno = 0, di = readdir(d); di; errno = 0, di = readdir(d)) {
+//		// Simulate IO error on the source
+//		int rando = rand();
+//		if (am_sender && (rando % 100) == 0) {
+//			errno = EIO;
+//			break;
+//		}
+		
 		char *dname = d_name(di);
 		if (dname[0] == '.' && (dname[1] == '\0'
 		    || (dname[1] == '.' && dname[2] == '\0')))
 			continue;
-		if (strlcpy(p, dname, remainder) >= remainder) {
+		unsigned name_len = strlcpy(p, dname, remainder);
+		if (name_len >= remainder) {
+			char save = fbuf[len];
+			fbuf[len] = '\0';
 			io_error |= IOERR_GENERAL;
 			rprintf(FERROR_XFER,
-				"cannot send long-named file %s\n",
-				full_fname(fbuf));
+				"send_directory: filename overflows max-path len by %u: %s/%s: (%d)\n",
+				name_len - remainder + 1, full_fname(fbuf), dname, ENAMETOOLONG);
+			fbuf[len] = save;
 			continue;
 		}
+		
+		// If the filename is nearly 255 characters, it could be a mangled
+		// name. In that case, we need to call getattrlist to determine
+		// ATTR_CMN_NAME
+		if (strlen(dname) >= 250) {
+			if (verbose > 1)
+				fprintf(stderr, "strlen(%s): %lu\n", dname, (unsigned long)strlen(dname));
+			char *realname;
+			struct attrlist attrs;
+			struct {
+				u_int32_t len;
+				attrreference_t obj_name_ref;
+				char obj_name_buf[769]; /* Large enough for 255 3-byte characters + '\0' */
+			} attrData;
+			
+			bzero(&attrs, sizeof(attrs));
+			attrs.bitmapcount = ATTR_BIT_MAP_COUNT;
+			attrs.commonattr = ATTR_CMN_NAME;
+
+			bzero(&attrData, sizeof(attrData));
+			int result = getattrlist(fbuf, &attrs, &attrData, sizeof(attrData), FSOPT_NOFOLLOW);
+			if (result == 0) {
+				/* Pick out the [UTF-8 format] name: */
+				realname = ((char *)(&attrData.obj_name_ref) + attrData.obj_name_ref.attr_dataoffset);
+				realname[attrData.obj_name_ref.attr_length] = '\0';
+				dname = realname;
+
+				name_len = strlcpy(p, realname, remainder);
+				if (name_len >= remainder) {
+					char save = fbuf[len];
+					fbuf[len] = '\0';
+					io_error |= IOERR_GENERAL;
+					rprintf(FERROR_XFER,
+						"send_directory: filename overflows max-path len by %u: %s/%s: (%d)\n",
+						name_len - remainder + 1, full_fname(fbuf), realname, ENAMETOOLONG);
+					fbuf[len] = save;
+					continue;
+				}
+
+				if (verbose > 1)
+					fprintf(stderr, "chars: %d, bytes: %lu\n", (int)mbstowcs(0, realname, 0), (unsigned long)strlen(dname));
+
+			} else {
+				fprintf(stderr, "send_directory: getattrlist failed for \"%s\": (%d)\n", fbuf, errno);
+				// continue with dname
+
+				int n;
+				for(n=0; p[n] != 0x0000; n++)
+					printf("%x", p[n]);
+			}
+		}
+
+
 		if (dname[0] == '\0') {
 			io_error |= IOERR_GENERAL;
 			rprintf(FERROR_XFER,
@@ -1732,14 +2018,53 @@
 			continue;
 		}
 
+		// BOMBICH
+		// If this is a ._ file and f == -2, set filter_level to NO_FILTERS
+		// We can't simply protect ._ files, that would prevent otherwise-empty
+		// folders from being deleted. We can't allow a general delete because
+		// in some cases (HFS --> FAT32 for example), the AppleDouble file will
+		// not exist on the source but will exist on the destination 
+		if (f == -2 && dname[0] == '.' && dname[1] == '_') {
+			if (verbose > 1)
+				fprintf(stderr, "send_directory: Setting filter_level to NO_FILTERS for %s\n", dname);
+			filter_level = NO_FILTERS;
+		}
+		
 		send_file_name(f, flist, fbuf, NULL, flags, filter_level);
+		filter_level = saved_filter_level;
+		
+#ifdef PARSEABLE_OUTPUT
+		// If we're using incremental recursion and this directory has a lot of items in it, update the user
+		if (am_sender && inc_recurse && flist->used - start > 128) {
+			struct timeval now;
+			gettimeofday(&now, NULL);
+			unsigned long time_diff = msdiff(&last_update, &now);
+			
+			if (time_diff > 500) {
+				last_update = now;
+				rprintf(FINFO, "S;;;CP;;;CF;;;%s\n", fbuf);
+			}
+		} else {
+			heartbeat(fbuf);
+		}
+#endif
 	}
 
 	fbuf[len] = '\0';
-
+	
 	if (errno) {
 		io_error |= IOERR_GENERAL;
-		rsyserr(FERROR_XFER, errno, "readdir(%s)", full_fname(fbuf));
+		rsyserr(FERROR_XFER, errno, "[%s]send_directory: readdir(%s)", who_am_i(), full_fname(fbuf));
+		// TODO: This is the right time but the wrong place to send the IO error message.
+		// If we're incrementally recursing in a deep directory, the generator could start
+		// deleting before the IO error message is received, causing data loss
+//		if (!ignore_errors)
+//			send_msg_int(MSG_IO_ERROR, io_error);
+		if ((fbuf[0] == '.' && fbuf[1] == '\0') || inc_recurse) {
+			fprintf(stderr, inc_recurse ? "send_directory: Bailing due to IO error during incremental recursion\n" : "send_directory: Bailing due to IO error on the root folder\n");
+			closedir(d);
+			exit_cleanup(RERR_FILESELECT);
+		}
 	}
 
 	closedir(d);
@@ -1910,6 +2235,18 @@
 				interpret_stat_error(fbuf, True);
 				continue;
 			}
+
+#ifdef SUPPORT_HFS_COMPRESSION
+		if (st.st_flags & UF_COMPRESSED) {
+			if (preserve_hfs_compression > 0) {
+				st.st_size = 0;
+			} else
+				// If the sender's filesystem supports compression, then we'll be able to send the decompressed data fork
+				// and the decmpfs xattr will be hidden (not sent). As such, we need to strip the compression flag.
+				st.st_flags &= ~UF_COMPRESSED;
+		}
+#endif
+
 			send_file_name(f, flist, fbuf, &st, FLAG_TOP_DIR | flags, ALL_FILTERS);
 		} else
 			send_file_name(f, flist, fbuf, NULL, FLAG_TOP_DIR | flags, ALL_FILTERS);
@@ -2034,12 +2371,36 @@
 		     | (eol_nulls || reading_remotely ? RL_EOL_NULLS : 0);
 	int implied_dot_dir = 0;
 
-	rprintf(FLOG, "building file list\n");
+	// BOMBICH -- I'd rather not see this message in the log file
+	//rprintf(FLOG, "building file list\n");
 	if (show_filelist_p())
 		start_filelist_progress("building file list");
-	else if (inc_recurse && verbose && !am_server)
+	else if (inc_recurse && verbose > 1 && !am_server)
 		rprintf(FCLIENT, "sending incremental file list\n");
 
+	stats.num_xattrs = 0;
+
+	// BOMBICH
+	stats.num_dirs = 0;
+	stats.num_reg_files = 0;
+	stats.num_symlinks = 0;
+	stats.num_devices = 0;
+	stats.num_special = 0;
+	stats.hard_links_not_copied = 0;
+
+//	// If we are doing incremental recursion, report the amount of space used on the source
+//	// Unfortunately, we don't know the size of compressed xattrs unless we read them, and that
+//	// incurs a significant performance penalty. As a result, however much data is compressed
+//	// would not be reported as processed
+//#ifdef PARSEABLE_OUTPUT
+//	if (inc_recurse) {
+//		struct statfs fsb;
+//		
+//		if (statfs(argv[0], &fsb) == 0)
+//			rprintf(FINFO, "S;;;FTC;;;TS;;;%llu\n", ((unsigned long long)fsb.f_blocks - (unsigned long long)fsb.f_bavail) * (unsigned)fsb.f_bsize);
+//	}
+//#endif
+//
 	start_write = stats.total_written;
 	gettimeofday(&start_tv, NULL);
 
@@ -2061,7 +2422,7 @@
 	disable_buffering = io_start_buffering_out(f);
 	if (filesfrom_fd >= 0) {
 		if (argv[0] && !change_dir(argv[0], CD_NORMAL)) {
-			rsyserr(FERROR_XFER, errno, "change_dir %s failed",
+			rsyserr(FERROR_XFER, errno, "send_file_list: change_dir %s failed",
 				full_fname(argv[0]));
 			exit_cleanup(RERR_FILESELECT);
 		}
@@ -2202,11 +2563,22 @@
 		 || (name_type != DOTDIR_NAME && is_daemon_excluded(fbuf, S_ISDIR(st.st_mode)))
 		 || (relative_paths && path_is_daemon_excluded(fbuf, 1))) {
 			io_error |= IOERR_GENERAL;
-			rsyserr(FERROR_XFER, errno, "link_stat %s failed",
-				full_fname(fbuf));
+			rsyserr(FERROR_XFER, errno, "[%s]send_file_list: link_stat %s failed",
+				who_am_i(), full_fname(fbuf));
 			continue;
 		}
 
+#ifdef SUPPORT_HFS_COMPRESSION
+		if (st.st_flags & UF_COMPRESSED) {
+			if (preserve_hfs_compression > 0) {
+				st.st_size = 0;
+			} else
+				// If the sender's filesystem supports compression, then we'll be able to send the decompressed data fork
+				// and the decmpfs xattr will be hidden (not sent). As such, we need to strip the compression flag.
+				st.st_flags &= ~UF_COMPRESSED;
+		}
+#endif
+
 		/* A dot-dir should not be excluded! */
 		if (name_type != DOTDIR_NAME
 		 && is_excluded(fbuf, S_ISDIR(st.st_mode) != 0, ALL_FILTERS))
@@ -2272,7 +2644,10 @@
 		idev_destroy();
 #endif
 
+// BOMBICH
+#ifndef PARSEABLE_OUTPUT
 	if (show_filelist_p())
+#endif
 		finish_filelist_progress(flist);
 
 	gettimeofday(&end_tv, NULL);
@@ -2348,13 +2723,18 @@
 	int64 start_read;
 	int save_verbose = verbose;
 
-	if (!first_flist)
-		rprintf(FLOG, "receiving file list\n");
+	// BOMBICH -- I don't want extraneous items going to the log
+	if (verbose > 1)
+		rprintf(FINFO, "receiving file list\n");
 	if (show_filelist_p())
 		start_filelist_progress("receiving file list");
-	else if (inc_recurse && verbose && !am_server && !first_flist)
+	else if (inc_recurse && verbose > 1 && !am_server && !first_flist)
 		rprintf(FCLIENT, "receiving incremental file list\n");
 
+	// BOMBICH
+	if (!first_flist) 
+		stats.num_dirs = 0;
+	
 	start_read = stats.total_read;
 
 #ifdef SUPPORT_HARD_LINKS
@@ -2902,7 +3282,9 @@
 int f_name_cmp(const struct file_struct *f1, const struct file_struct *f2)
 {
 	int dif;
+	int case_conflict = 0;
 	const uchar *c1, *c2;
+	uchar ch1, ch2;
 	enum fnc_state state1, state2;
 	enum fnc_type type1, type2;
 	enum fnc_type t_path = protocol_version >= 29 ? t_PATH : t_ITEM;
@@ -3006,15 +3388,35 @@
 			case s_TRAILING:
 				found_prefix = 1;
 				if (!*c1)
-					return 0;
+					return (detect_case_conflicts > 1 && dif == 0 && case_conflict == 0) ? 1 : 0;
 				type2 = t_ITEM;
 				break;
 			}
 			if (type1 != type2)
 				return type1 == t_PATH ? 1 : -1;
 		}
-	} while ((dif = (int)*c1++ - (int)*c2++) == 0);
+		ch1 = *c1++;
+		ch2 = *c2++;
+		if (detect_case_conflicts > 1) {
+			int ch1Upper = isupper(ch1);
+			int ch2Upper = isupper(ch2);
+			if (ch1Upper)
+				ch1 = tolower(ch1);
+			if (ch2Upper)
+				ch2 = tolower(ch2);
+			
+			if (case_conflict == 0) {
+				if ((int)ch1 - (int)ch2 == 0 && ch1Upper != ch2Upper) {
+					case_conflict = 1;
+				}
+			}
+		}
+	} while ((dif = (int)ch1 - (int)ch2) == 0);
 
+	if (detect_case_conflicts > 1 && dif == 0 && case_conflict == 0) {
+		return 1; // No match if we didn't find a case conflict
+	}
+	
 	return dif;
 }
 
